import com.cycling74.max.Atom;
import com.cycling74.max.DataTypes;
import com.cycling74.max.MaxObject;


public class smooth_func  extends MaxObject {
	smooth_func (Atom[] a) {
		declareInlets(new int[]{DataTypes.ALL});
		declareOutlets(new int[]{DataTypes.ALL});
		createInfoOutlet(false);	}

	// little patch by Alexandre Flet (alexf1975 at yahoo.fr)
	
	int size = 1000 ; 
	float adjustcurve = 0.33333f ; public void adjustcurve(float val) {
		adjustcurve = val ;  calc() ; }
	
	
//	float fac1 ; public void fac1(float val){fac1 = val ;  calc() ; }
//	float fac2a ; public void fac2a(float val){fac2a = val ;  calc() ; }
//	float fac2b ; public void fac2b(float val){fac2b = val ;  calc() ; }
//	float fac2c ; public void fac2c(float val){fac2c = val ;  calc() ; }
//	float fac3a ; public void fac3a(float val){fac3a = val ;  calc() ; }
//	float fac3b ; public void fac3b(float val){fac3b = val ;  calc() ; }
	
	int algo = 1 ; public void algo(int val) {
		algo = val ;  calc() ; }
	  
	float [] mode  = new float [2] ; 
	float [] slopeslimit  = new float [2] ;
	
	float [] multi  = new float [10];  // multislider in
	float [] multih  = new float [12];  // multislider in (hermite algorythm)
	float [] multo  = new float [size];  // multislider out
	
	
	public void init() {
		mode [0] = 0f ;
		mode [1] = 1f ;
		slopeslimit [0] = 0f ;
		slopeslimit [1] = 0f ;
		outlet(0, "init smooth_fonc class." ) ;
	}
	public void mode(float [] data) {	mode = data ;  calc() ; }
	
	public void slopeslimit(float [] data) { slopeslimit = data ; calc() ; }
	
	public void first(float [] data) {
		slopeslimit[0] = data[0]*3 ;
		slopeslimit[0] = slopeslimit[0]*slopeslimit[0]*slopeslimit[0] ;
		mode [0] = data[1] + 0.5f ;  
		calc() ;
	}
	public void last(float [] data) {
		slopeslimit[1] = - data[1]*3 ;
		slopeslimit[1] = slopeslimit[1]*slopeslimit[1]*slopeslimit[1] ;
		mode [1] = data[0] + 0.5f ;
		adjustcurve = data[2] * 10f   ;   
		calc() ;
	}
	
	public void size(int value) {	
		size = value ; float [] m = new float [size]; multo = m ;
		; calc() ; }
	
	public void inlet(float value) {
		float [] m  = new float [3];
		
		m[1] = value ;
		
		multi = m ; 
		calc() ;
	}
	public void list(float[] values) {
		float [] m  = new float [values.length+2];
		for (int i=1 ; i<m.length-1 ; i++) {
			m[i] = values[i-1] ;
		}
		multi = m ; 
		calc() ;
	}
	
	public void calc() {
		
		if (adjustcurve==5) {
		
			calc_hermite() ;
			
		}else{
			
			multi[0] = mode [0] ; 
			multi[multi.length-1] = mode [1] ;
			
			int sizei = multi.length ; 
			
			float [] pp = new float [sizei] ;  // slopes means for each slider
			pp[0] = slopeslimit [0] ; // first slope : normaly 0
			pp[sizei-1] = slopeslimit [1] ; //  last slope : normaly 0
			
			for (int i=1 ; i<sizei-1 ; i++) {
				pp[i] = (multi[i+1]-multi[i-1]) / 2  ; //mean of slopes (i+1)-(i) and (i)-(i-1) 
			}

			float [] multol1  = new float [size];
			
			float delta, deltam, ii, p, brut, line1,line2, curve3, scurv, faccos, coscurv ;
			float deltamix , adjustcurveo;
			adjustcurveo = adjustcurve ;
			if (adjustcurve>1) { adjustcurveo = 0.3333f ; }
			
			for (int i=0 ; i<size ; i++) {
				ii= ((float)i) / ((float)size) * ((float)sizei-1) ;
				if ((int)ii<sizei-1) {
					
					delta =  ii - (int)ii;
					deltam = 0.5f - (float)Math.cos(delta*3.14159265)/2  ;
						
					p = multi[(int)ii+1]-multi[(int)ii] ;  // slope ((int)ii+1)-((int)ii)
					
					brut = delta*p + multi[(int)ii] ;  // simple interpolation
					line1 = delta*pp[(int)ii] + multi[(int)ii] ;
					line2 = (delta-1)*pp[(int)ii+1] + multi[(int)ii+1] ;
					curve3 = (line1*(1-deltam) + line2*(deltam))  / 2 ;
					
					if (delta<0.5){
						deltamix = delta * 2 ;
						coscurv= ((float)Math.cos(delta *2 *3.14159265)+1) * multi[(int)ii] /2 ; 
					}else{
						deltamix = (1 - delta) * 2 ;
						coscurv= (1-(float)Math.cos((delta-0.5) *2 *3.14159265)) * multi[(int)ii+1] /2 ; 
					}
					deltamix = (float)Math.pow(deltamix,adjustcurveo)   ;
					
					faccos = (adjustcurve-1f) / 4f ;
					if (faccos<0) {faccos=0;} 
					
					scurv = (curve3*2)*(1-deltamix)+((curve3 * 2 - brut)/2 + brut)*deltamix;
					
					
					multol1[i]= scurv*(1-faccos) + coscurv*faccos  ;
					//multol1[i] = curve3*2 ;
					
				} else {
					multol1[i] = mode [1]    ;
				}
			}
			
			
			outlet(0, multol1) ;
		}
	}
	
	public void calc_hermite() {
		
		multi[0] = mode [0] ; 
		multi[multi.length-1] = mode [1] ;
		float [] m  = new float [multi.length+2];
		for (int i=1 ; i<m.length-1 ; i++) {
			m[i] = multi[i-1] ;
		}
		
		multih = m ; 
		multih[0] = multih[2] - (slopeslimit[0]*2f) ; 
		multih[multih.length-1] = multih[multih.length-3] + (slopeslimit[1]*2f) ;
		
		float delta, ii  , ym1,y0,y1,y2,par1,par2,par3;
		//deltaoo = size*2/(multi.length-4) ;
		//sizeoo = 
		for (int i=0 ; i<size ; i++) {
			ii= ((float)i) * ((float)multih.length-3) / ((float)size) ;
			ii = ii + 2 ;
			delta =  ii - (int)ii;
			ym1 = multih[(int)ii-1 -1] ;
			y0 = multih[(int)ii -1] ;
			y1 = multih[(int)ii+1 -1] ;
			y2 = multih[(int)ii+2 -1] ;
			
//			par1 = (y1-ym1)*fac1 ;
//			par2 = ym1 - fac2a*y0 + fac2b*y1 - fac2c*y2 ;
//			par3 = fac3a*(y0-y1) + fac3b*(y2-ym1) ;
			
			par1 = (y1-ym1)*0.5f ;
			par2 = ym1 - 2.5f*y0 + 2f*y1 - 0.5f*y2 ;
			par3 = 1.5f*(y0-y1) + 0.5f*(y2-ym1) ;
			
			multo[i] = ((par3*delta + par2)*delta + par1)*delta + y0  ;	
			
		}
		
		outlet(0, multo) ;
		
	}
	
}	


